/*
 * @Author       : ChenJie
 * @Date         : 2021-12-20 14:47:39
 * @Version      : V3.0
 * @LastEditors  : ChenJie
 * @LastEditTime : 2021-12-29 16:33:32
 * @Description  : file content
 * @FilePath     : \VehicleControl\VehicleControl\src\System\Vehicle\Communication\BleCanProtocolFunc.c
 */
/*
 * CanProtocol.c
 * canЭת
 *  Created on: 20211220
 *      Author: QiXiang_CHENJIE
 */
#include "BleCanProtocolFunc.h"
#include "HardwareLib.h"
/**
 * @brief : EBCbleӦ,ATָ,EBC(0x1CEE000X)->BLE(0x1CEF0000X)
 * @param {uint8} CmdIdx
 * @return {*}
 */
void Can2ProtocolCode(uint8 CmdIdx)
{
    uint8 BlePwrControl;       //Դؿ  FF-رգ0A-
    uint8 BlePwrControl_Flag;  //Դؿʹ  00-ƣ01-
    uint8 BleRoleControl;      //ӿ  01-02-ӻ
    uint8 BleRoleControl_Flag; //ӿʹ  00-ƣ01-
    uint8 BleName[8];
    uint32 InnerCanID;
    uint8 Data[8];
    uint8 DataIdx;
    uint8 Byte0Num;
    // CmdIdx EBCBLEб
    switch (CmdIdx)
    {
    case 0x00: // ebc->bleݴͨ
    {
        Can2DataCode(DataIdx, Byte0Num);
        InnerCanID = 0x1CEE0000;
        break;
    }
    case 0x01: //ѯBLE汾
    {
        Data[0] = 0x01;
        Data[1] = 0x00;
        Data[2] = 0x00;
        Data[3] = 0x00;
        Data[4] = 0x00;
        Data[5] = 0x00;
        Data[6] = 0x00;
        Data[7] = 0x00;
        InnerCanID = 0x1CEE0001;
        break;
    }
    case 0x02: //ѯBLE״̬
    {
        Data[0] = 0x01;
        Data[1] = 0x00;
        Data[2] = 0x00;
        Data[3] = 0x00;
        Data[4] = 0x00;
        Data[5] = 0x00;
        Data[6] = 0x00;
        Data[7] = 0x00;
        InnerCanID = 0x1CEE0002;
        break;
    }
    case 0x03: //BLEϿ
    {
        Data[0] = 0x02;
        Data[1] = 0x00;
        Data[2] = 0x00;
        Data[3] = 0x00;
        Data[4] = 0x00;
        Data[5] = 0x00;
        Data[6] = 0x00;
        Data[7] = 0x00;
        InnerCanID = 0x1CEE0003;
        break;
    }
    case 0x04: //豸 ΪASCIIֵ
    {
        Data[0] = BleName[0];
        Data[1] = BleName[1];
        Data[2] = BleName[2];
        Data[3] = BleName[3];
        Data[4] = BleName[4];
        Data[5] = BleName[5];
        Data[6] = BleName[6];
        Data[7] = BleName[7];
        InnerCanID = 0x1CEE0004;
        break;
    }
    case 0x05: // BLE豸زѯƣĬΪѯ
    {
        if (BlePwrControl_Flag)
        {
            Data[0] = 0x02;
            Data[1] = BlePwrControl;
        }
        else
        {
            Data[0] = 0x01;
            Data[1] = 0x00;
        }
        Data[2] = 0x00;
        Data[3] = 0x00;
        Data[4] = 0x00;
        Data[5] = 0x00;
        Data[6] = 0x00;
        Data[7] = 0x00;
        InnerCanID = 0x1CEE0005;
        break;
    }
    case 0x06: // BLE ӻлѯĬΪѯ
    {
        if (BleRoleControl_Flag)
        {
            Data[0] = 0x02;
            Data[1] = BleRoleControl;
        }
        else
        {
            Data[0] = 0x01;
            Data[1] = 0x00;
        }
        Data[2] = 0x00;
        Data[3] = 0x00;
        Data[4] = 0x00;
        Data[5] = 0x00;
        Data[6] = 0x00;
        Data[7] = 0x00;
        InnerCanID = 0x1CEE0006;
        break;
    }
    default:
        break;
    }
}
/**
 * @brief : ebcbleӦ,Ebc data ->Ble data
 * @param {*}
 * @return {*}
 */
void Can2DataCode(uint8 DataIdx, uint8 Byte0Num)
{
    uint8 Data[8];
    switch (DataIdx)
    {
    case 0x01: //1Ӧ
    {
        Data[0] = 0x11;
        Data[1] = ebcd_st_ebcWork;
        Data[2] = ebcd_st_ebcConnect;
        Data[3] = ebcd_st_ebcLockWork;
        Data[4] = 0x00;
        Data[5] = 0x00;
        Data[6] = 0x00;
        Data[7] = 0x00;
        break;
    }
    case 0x02: //2Ӧ 7
    {
        switch (Byte0Num)
        {
        case 0x21:
        {
            vcud_st_keyOn = 0;        // TBD
            bcud_st_bcuTmsLiquid = 0; // TBD
            Data[0] = Byte0Num;
            Data[1] = ebcd_st_unlockSensor;
            Data[2] = ebcd_st_lockSensor;
            Data[3] = vcud_st_keyOn;
            Data[4] = ebcd_P_airSensor;
            Data[5] = bcud_st_bcuTmsLiquid;
            Data[6] = ebcd_flg_pluginLockSig;
            Data[7] = 0x00;
            break;
        }
        case 0x22:
        {
            Data[0] = Byte0Num;
            Data[1] = 0x00;
            Data[2] = 0x00;
            Data[3] = 0x00;
            Data[4] = 0x00;
            Data[5] = ebcd_st_pedstSensor;
            Data[6] = ebcd_st_pluginLockSig;
            Data[7] = 0x00;
            break;
        }
        case 0x23:
        {
            Data[0] = Byte0Num;
            Data[1] = ebcd_st_unlockSucJug;
            Data[2] = ebcd_st_lockSucJug;
            Data[3] = 0x00;
            Data[4] = 0x00;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            break;
        }
        case 0x24:
        {
            Data[0] = Byte0Num;
            Data[1] = 0x00;
            Data[2] = 0x00;
            Data[3] = 0x00;
            Data[4] = 0x00;
            Data[5] = ebcd_st_pedstSucJug;
            Data[6] = ebcd_flg_swapAdmit;
            Data[7] = 0x00;
            break;
        }
        case 0x25:
        {
            Data[0] = Byte0Num;
            Data[1] = ebcd_st_ebcWork;
            Data[2] = ebcd_st_ebcConnect;
            Data[3] = ebcd_st_ebcLockWork;
            Data[4] = ebcd_Nr_errMax;
            Data[5] = ebcd_Num_err1;
            Data[6] = ebcd_Num_err2;
            Data[7] = 0x00;
            break;
        }
        case 0x26:
        {
            Data[0] = Byte0Num;
            Data[1] = (ebcd_Nr_swapBatt >> 8) & 0xFF;
            Data[2] = ebcd_Nr_swapBatt & 0xFF;
            Data[3] = (ebcd_Nr_swapSucBatt >> 8) & 0xFF;
            Data[4] = ebcd_Nr_swapSucBatt;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            break;
        }
        case 0x27:
        {
            Data[0] = Byte0Num;
            Data[1] = ebcd_st_errTable1;
            Data[2] = ebcd_st_errTable2;
            Data[3] = ebcd_st_errTable3;
            Data[4] = 0x00;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            break;
        }
        default:
            break;
        }
        break;
    }
    case 0x03: //3Ӧ 5
    {
        vcud_st_handbrake = HandbrakeSts;
        vcud_st_footbrake = (BrakePedal > 0);
        vcud_st_gear = GearPos;
        vcud_st_vcuComun = (VCU_Life != 0xFF);
        vcud_st_carStart = VehSts;
        vcud_st_Steer = 0x00; // TBD
        vcud_M_accDrv = VCU_TotalDistance * 10;
        if (EBC_VinMsgFlag == 0x07)
        {
            memcpy(vcuv_Num_vin, VCU_VIN, 17);
        }
        switch (Byte0Num)
        {
        case 0x31:
        {
            Data[0] = Byte0Num;
            Data[1] = vcud_st_handbrake;
            Data[2] = vcud_st_footbrake;
            Data[3] = vcud_st_gear;
            Data[4] = vcud_st_vcuComun;
            Data[5] = vcud_st_carStart;
            Data[6] = vcud_st_Steer;
            Data[7] = 0x00;
            break;
        }
        case 0x32:
        {
            Data[0] = Byte0Num;
            Data[1] = vcuv_Num_vin[0];
            Data[2] = vcuv_Num_vin[1];
            Data[3] = vcuv_Num_vin[2];
            Data[4] = vcuv_Num_vin[3];
            Data[5] = vcuv_Num_vin[4];
            Data[6] = vcuv_Num_vin[5];
            Data[7] = 0x00;
            break;
        }
        case 0x33:
        {
            Data[0] = Byte0Num;
            Data[1] = vcuv_Num_vin[6];
            Data[2] = vcuv_Num_vin[7];
            Data[3] = vcuv_Num_vin[8];
            Data[4] = vcuv_Num_vin[9];
            Data[5] = vcuv_Num_vin[10];
            Data[6] = vcuv_Num_vin[11];
            Data[7] = 0x00;
            break;
        }
        case 0x34:
        {
            Data[0] = Byte0Num;
            Data[1] = vcuv_Num_vin[12];
            Data[2] = vcuv_Num_vin[13];
            Data[3] = vcuv_Num_vin[14];
            Data[4] = vcuv_Num_vin[15];
            Data[5] = vcuv_Num_vin[16];
            Data[6] = 0x00;
            Data[7] = 0x00;
            break;
        }
        case 0x35:
        {
            Data[0] = Byte0Num;
            Data[1] = (vcud_M_accDrv >> 24) & 0xFF;
            Data[2] = (vcud_M_accDrv >> 16) & 0xFF;
            Data[3] = (vcud_M_accDrv >> 8) & 0xFF;
            Data[4] = (vcud_M_accDrv)&0xFF;
            Data[5] = vcud_P_airSensorForward;
            Data[6] = vcud_P_airSensorBack;
            Data[7] = 0x00;
            break;
        }
        default:
            break;
        }
        break;
    }
    case 0x04: //4Ӧ 16
    {
        bcud_st_bcuComun = (BMS1_Life != 0xFF);
        bcud_pct_bcuSoh = BMS2_SOH;

        bcud_V_battU = BMS2_PackInsideVolt;
        if (BMS1_SysSts == 2)
        {
            bcud_st_hvWork = 0;
        }
        else if (BMS1_SysSts == 0 || BMS1_SysSts == 1)
        {
            bcud_st_hvWork = 1;
        }
        else if (BMS1_SysSts == 3)
        {
            bcud_st_hvWork = 2;
        }
        else
        {
            bcud_st_hvWork = 3;
        }
        bcud_st_bcuMainRelay = BMS1_MainPosRelaySt;
        bcud_pct_soc = (UINT16)(BMS2_SOC * 4);
        memcpy(bcuv_Num_battSn, BMS_SN_SysCode, sizeof(BMS_SN_SysCode));
        bcud_Q_snglChrg = BMS19_SingleChargeAh;
        bcud_E_snglChrg = BMS19_SingleChargeKwh;
        bcud_Q_accRecovry = BMS16_TotalEneryECOChargeAh;
        bcud_E_accRecovry = BMS16_TotalEneryECOChargeKwh;
        bcud_Q_accSwapBatt = BMS17_TotalStationChargeAh;
        bcud_E_accSwapBatt = BMS17_TotalStationChargeKwh;
        bcud_Q_accPlugInChrg = BMS18_TotalPoleChargeAh;
        bcud_E_accPlugInChrg = BMS18_TotalPoleChargeKwh;
        bcud_Q_accDischrg = BMS14_TotalDischargeAh;
        bcud_E_accDischrg = BMS14_TotalDischargeAh;
        bcud_Q_accChrg = BMS18_TotalPoleChargeAh;
        bcud_E_accChrg = BMS15_TotalChargeKwh;
        switch (Byte0Num)
        {
        case 0x40:
        {
            Data[0] = Byte0Num;
            Data[1] = (bcud_E_accPlugInChrg >> 24) & 0xFF;
            Data[2] = (bcud_E_accPlugInChrg >> 16) & 0xFF;
            Data[3] = (bcud_E_accPlugInChrg >> 8) & 0xFF;
            Data[4] = (bcud_E_accPlugInChrg)&0xFF;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            break;
        }
        case 0x41:
        {
            Data[0] = Byte0Num;
            Data[1] = (bcud_Q_accChrg >> 24) & 0xFF;
            Data[2] = (bcud_Q_accChrg >> 16) & 0xFF;
            Data[3] = (bcud_Q_accChrg >> 8) & 0xFF;
            Data[4] = (bcud_Q_accChrg)&0xFF;
            Data[5] = bcud_st_bcuComun;
            Data[6] = bcud_st_hvWork;
            Data[7] = 0x00;
            break;
        }
        case 0x42:
        {
            Data[0] = Byte0Num;
            Data[1] = (bcud_Q_accDischrg >> 24) & 0xFF;
            Data[2] = (bcud_Q_accDischrg >> 16) & 0xFF;
            Data[3] = (bcud_Q_accDischrg >> 8) & 0xFF;
            Data[4] = (bcud_Q_accDischrg)&0xFF;
            Data[5] = bcud_st_bcuMainRelay;
            Data[6] = bcud_pct_bcuSoh;
            Data[7] = 0x00;
            break;
        }
        case 0x43:
        {
            Data[0] = Byte0Num;
            Data[1] = (bcud_E_accChrg >> 24) & 0xFF;
            Data[2] = (bcud_E_accChrg >> 16) & 0xFF;
            Data[3] = (bcud_E_accChrg >> 8) & 0xFF;
            Data[4] = (bcud_E_accChrg)&0xFF;
            Data[5] = (bcud_V_battU >> 8) & 0xFF;
            Data[6] = (bcud_V_battU)&0xFF;
            Data[7] = 0x00;
            break;
        }
        case 0x44:
        {
            Data[0] = Byte0Num;
            Data[1] = (bcud_E_accDischrg >> 24) & 0xFF;
            Data[2] = (bcud_E_accDischrg >> 16) & 0xFF;
            Data[3] = (bcud_E_accDischrg >> 8) & 0xFF;
            Data[4] = (bcud_E_accDischrg)&0xFF;
            Data[5] = (bcud_pct_soc >> 8) & 0xFF;
            Data[6] = (bcud_pct_soc)&0xFF;
            Data[7] = 0x00;
            break;
        }
        case 0x45:
        {
            Data[0] = Byte0Num;
            Data[1] = bcuv_Num_battSn[0];
            Data[2] = bcuv_Num_battSn[1];
            Data[3] = bcuv_Num_battSn[2];
            Data[4] = bcuv_Num_battSn[3];
            Data[5] = bcuv_Num_battSn[4];
            Data[6] = bcuv_Num_battSn[5];
            Data[7] = 0x00;
            break;
        }
        case 0x46:
        {
            Data[0] = Byte0Num;
            Data[1] = bcuv_Num_battSn[6];
            Data[2] = bcuv_Num_battSn[7];
            Data[3] = bcuv_Num_battSn[8];
            Data[4] = bcuv_Num_battSn[9];
            Data[5] = bcuv_Num_battSn[10];
            Data[6] = bcuv_Num_battSn[11];
            Data[7] = 0x00;
            break;
        }
        case 0x47:
        {
            Data[0] = Byte0Num;
            Data[1] = bcuv_Num_battSn[12];
            Data[2] = bcuv_Num_battSn[13];
            Data[3] = bcuv_Num_battSn[14];
            Data[4] = bcuv_Num_battSn[15];
            Data[5] = bcuv_Num_battSn[16];
            Data[6] = bcuv_Num_battSn[17];
            Data[7] = 0x00;
            break;
        }
        case 0x48:
        {
            Data[0] = Byte0Num;
            Data[1] = bcuv_Num_battSn[18];
            Data[2] = bcuv_Num_battSn[19];
            Data[3] = bcuv_Num_battSn[20];
            Data[4] = bcuv_Num_battSn[21];
            Data[5] = bcuv_Num_battSn[22];
            Data[6] = bcuv_Num_battSn[23];
            Data[7] = 0x00;
            break;
        }
        case 0x49:
        {
            Data[0] = Byte0Num;
            Data[1] = bcuv_Num_battSn[24];
            Data[2] = bcuv_Num_battSn[25];
            Data[3] = bcuv_Num_battSn[26];
            Data[4] = bcuv_Num_battSn[27];
            Data[5] = bcuv_Num_battSn[28];
            Data[6] = bcuv_Num_battSn[29];
            Data[7] = 0x00;
            break;
        }
        case 0x4A:
        {
            Data[0] = Byte0Num;
            Data[1] = bcuv_Num_battSn[30];
            Data[2] = bcuv_Num_battSn[31];
            Data[3] = 0x00;
            Data[4] = 0x00;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            break;
        }
        case 0x4B:
        {
            Data[0] = Byte0Num;
            Data[1] = (bcud_Q_snglChrg >> 8) & 0xFF;
            Data[2] = (bcud_Q_snglChrg)&0xFF;
            Data[3] = (bcud_Q_accRecovry >> 24) & 0xFF;
            Data[4] = (bcud_Q_accRecovry >> 16) & 0xFF;
            Data[5] = (bcud_Q_accRecovry >> 8) & 0xFF;
            Data[6] = (bcud_Q_accRecovry)&0xFF;
            Data[7] = 0x00;
            break;
        }
        case 0x4C:
        {
            Data[0] = Byte0Num;
            Data[1] = (bcud_Q_accSwapBatt >> 24) & 0xFF;
            Data[2] = (bcud_Q_accSwapBatt >> 16) & 0xFF;
            Data[3] = (bcud_Q_accSwapBatt >> 8) & 0xFF;
            Data[4] = (bcud_Q_accSwapBatt)&0xFF;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            break;
        }
        case 0x4D:
        {
            Data[0] = Byte0Num;
            Data[1] = (bcud_E_snglChrg >> 8) & 0xFF;
            Data[2] = (bcud_E_snglChrg)&0xFF;
            Data[3] = (bcud_E_accRecovry >> 24) & 0xFF;
            Data[4] = (bcud_E_accRecovry >> 16) & 0xFF;
            Data[5] = (bcud_E_accRecovry >> 8) & 0xFF;
            Data[6] = (bcud_E_accRecovry)&0xFF;
            Data[7] = 0x00;
            break;
        }
        case 0x4E:
        {
            Data[0] = Byte0Num;
            Data[1] = (bcud_E_accSwapBatt >> 24) & 0xFF;
            Data[2] = (bcud_E_accSwapBatt >> 16) & 0xFF;
            Data[3] = (bcud_E_accSwapBatt >> 8) & 0xFF;
            Data[4] = (bcud_E_accSwapBatt)&0xFF;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            break;
        }
        case 0x4F:
        {
            Data[0] = Byte0Num;
            Data[1] = (bcud_Q_accPlugInChrg >> 24) & 0xFF;
            Data[2] = (bcud_Q_accPlugInChrg >> 16) & 0xFF;
            Data[3] = (bcud_Q_accPlugInChrg >> 8) & 0xFF;
            Data[4] = (bcud_Q_accPlugInChrg)&0xFF;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            break;
        }
        default:
            break;
        }
    }
    case 0x05:
    {
        Data[0] = 0x51;
        Data[1] = 0x00;
        Data[2] = 0x00;
        Data[3] = 0x00;
        Data[4] = 0x00;
        Data[5] = 0x00;
        Data[6] = 0x00;
        Data[7] = 0x00;
    }
    default:
        break;
    }
}

/**
 * @brief : EbcͨCan2ܵЭ
 * @param {uint8} CmdIdx
 * @return {*}
 */
void Can2ProtocolDecode(uint8 CmdIdx)
{
    uint32 Can2ID;
    uint8 Data[8];
    switch (Can2ID)
    {
    case 0x0000:
    {
        Can2DataDecode();
        bled_flg_bleConn = 1;
        break;
    }
    case 0x0001:
    {
        bled_Nr_softVer = (Data[0] << 24) | (Data[1] << 16) | (Data[2] << 8) | (Data[3]);
        break;
    }
    case 0x0002:
    {
        if (Data[0] != 0xFF)
        {
            bled_flg_bleConn = 1;
        }
        else
        {
            bled_flg_bleConn = 0;
        }
        break;
    }
    default:
        break;
    }
}
/**
 * @brief : Ebcͨcan2յݽ,Ble->Ebc
 * @param {*}
 * @return {*}
 */
void Can2DataDecode(void)
{
    uint8 Data[8];
    uint8 CmdIndex = Data[0];
    switch (CmdIndex)
    {
    case 0x01: //ݣΪάͨѶ
    {
        bled_flg_Heart = 1;
        break;
    }
    case 0x02: //ȡϢ
    {
        bled_flg_getEbcData = 1;
        break;
    }
    case 0x03: //óϢ
    {
        bled_flg_getVcuData = 1;
        break;
    }
    case 0x04: //ȡϢ
    {
        bled_flg_getBmsData = 1;
        break;
    }
    case 0x05: //
    {
        bled_flg_handShake = 1;
        break;
    }
    case 0x06: //
    {
        bled_flg_unlockCmd = Data[1];
        break;
    }
    case 0x07: //
    {
        bled_flg_lockCmd = Data[1];
        break;
    }
    case 0x08: //ɻ
    {
        bled_flg_swapBattDone = 1;
        break;
    }
    case 0x09: //ǿƽǿ
    {
        bled_flg_unlockCmdForce = Data[1];
        bled_flg_topAscendCmdForce = Data[2];
        break;
    }
    case 0x0A: //ǿǿ½
    {
        bled_flg_lockCmdForce = Data[1];
        bled_flg_topDescendCmdForce = Data[2];
        break;
    }
    case 0x0B: //صг״̬
    {
        bled_flg_backToDrv = 1;
        break;
    }
    case 0x0C: //
    {
        bled_flg_topAscendCmd = Data[1];
        break;
    }
    case 0x0D: //½
    {
        bled_flg_topDescendCmd = Data[1];
        break;
    }
    case 0x0E: //翪ʼԶ
    {
        bled_flg_autoUnlock = 1;
        break;
    }
    case 0x0F: //Զ
    {
        bled_flg_autoLock = 1;
        break;
    }
    case 0x10: //ʼ
    {
        bled_flg_openDustReCmd = 1;
        break;
    }
    case 0x11: //ر
    {
        bled_flg_closeDustReCmd = 1;
        break;
    }
    case 0x12: //лͨ״̬
    {
        break;
    }
    case 0x13: //뻻״̬
    {
        bled_flg_toSwapMod = 1;
        break;
    }
    case 0x14: //ָͣ
    {
        bled_flg_safeStopCmd = 1;
        break;
    }
    default:
        break;
    }
}
