/*
 * @Author       : ChenJie
 * @Date         : 2021-12-27 11:21:08
 * @Version      : V3.0
 * @LastEditors  : ChenJie
 * @LastEditTime : 2021-12-30 13:59:24
 * @Description  : file content
 * @FilePath     : \VehicleControl\VehicleControl\src\System\Vehicle\Communication\CanVar.h
 */
/*
 * CanVar.h
 *
 *  Created on: 20211227
 *  
 *      Author: QiXiang_CHENJIE
 */

#ifndef SYSTEM_VEHICLE_COMMUNICATION_CANVAR_H_
#define SYSTEM_VEHICLE_COMMUNICATION_CANVAR_H_
#include "Std_Types.h"
#include "HardwareLib.h"
/************************************************************
 *BCU->Ebc
 ************************************************************/
extern UINT32 BcuInTable[130];
extern BOOL BcuRxShortError[130];
extern BOOL BcuRxLongError[130];
extern UINT8 BcuRxErrorCounter[130];
extern UINT8 BcuRxFlag[130];
extern UINT8 BMS13_ReqVIN;
extern UINT8 BMS11_Fult1_DelTemp;
extern UINT8 BMS11_Fult1_OverTemp;
extern UINT8 BMS11_Fult1_PackOverHVolt;
extern UINT8 BMS11_Fult1_PackLowHVolt;
extern UINT8 BMS11_Fult1_LowSOC;
extern UINT8 BMS11_Fult1_OverUcell;
extern UINT8 BMS11_Fult1_LowUcell;
extern UINT8 BMS11_Fult1_LowInsRes;
extern UINT8 BMS11_Fult1_UcellUniformity;
extern UINT8 BMS11_Fult1_OverChg;
extern UINT8 BMS11_Fult1_OverSOC;
extern UINT8 BMS11_Fult1_SOCChangeFast;
extern UINT8 BMS11_Fult1_BatSysNotMatch;
extern UINT8 BMS11_Fult1_HVILFault;
extern UINT8 BMS12_Fult2_FaultNum;
extern UINT8 BMS12_Fult2_CellOverDischrg;
extern UINT8 BMS12_Fult2_CellLowTemp;
extern UINT8 BMS12_Fult2_PackFireWarning;
extern UINT8 BMS12_Fult2_OverDischrgCurr;
extern UINT8 BMS12_Fult2_OverChrgCurrInTheDrive;
extern UINT8 BMS12_Fult2_CurrSensorErr;
extern UINT8 BMS12_Fult2_PowerSupplyErr;
extern UINT8 BMS12_Fult2_TMSErr;
extern UINT8 BMS12_Fult2_HeatingFilmErr;
extern UINT8 BMS12_Fult2_PackSelfProtect;
extern UINT8 BMS12_Fult2_MainLoopPrechrgErr;
extern UINT8 BMS12_Fult2_AuxLoopPrechrgErr;
extern UINT8 BMS12_Fult2_ChrgInsLowErr;
extern UINT8 BMS12_Fult2_ACANLost;
extern UINT8 BMS12_Fult2_InnerCommunicationErr;
extern UINT8 BMS12_Fult2_DCDCErr;
extern UINT8 BMS12_Fult2_BranchBreakErr;
extern UINT8 BMS12_Fult2_HeatRelayOpenErr;
extern UINT8 BMS12_Fult2_HeatRelayWeldErr;
extern UINT8 BMS12_Fult2_MainPosRelayOpenErr;
extern UINT8 BMS12_Fult2_MainPosRelayWeldErr;
extern UINT8 BMS12_Fult2_MainNegRelayOpenErr;
extern UINT8 BMS12_Fult2_MainNegRelayWeldErr;
extern UINT8 BMS12_Fult2_DCChrgPos1RelayOpenErr;
extern UINT8 BMS12_Fult2_DCChrgPos1RelayWeldErr;
extern UINT8 BMS12_Fult2_DCChrgNeg1RelayOpenErr;
extern UINT8 BMS12_Fult2_DCChrgNeg1RelayWeldErr;
extern UINT8 BMS12_Fult2_DCChrgPos2RelayOpenErr;
extern UINT8 BMS12_Fult2_DCChrgPos2RelayWeldErr;
extern UINT8 BMS12_Fult2_DCChrgNeg2RelayOpenErr;
extern UINT8 BMS12_Fult2_DCChrgNeg2RelayWeldErr;
extern UINT8 BMS12_Fult2_ChrgConnectErr;
extern UINT8 BMS12_ult2_OverDischrgCurrWhenInChrg;
extern UINT8 BMS12_Fult2_OverChrgCurrInTheChrg;
extern UINT8 BMS12_Fult2_ChrgNTCErr;
extern UINT8 BMS12_Fult2_ChrgNTCTempOver;
extern UINT8 BMS12_Fult2_ELockErr;
extern UINT8 BMS12_Fult2_FireDetectorEr;
extern UINT8 BMS12_Fult2_ContiDischrgCurrOverLoad;
extern UINT8 BMS12_Fult2_SOCDifferErr;
extern UINT8 BMS12_Fult2_ContiChrgCurrOverLoad;
extern UINT8 BMS1_MainPosRelaySt;
extern UINT8 BMS1_MainNegRelaySt;
extern UINT8 BMS1_PreChgRelaySt;
extern UINT8 BMS1_DCChrgPos1RelaySt;
extern UINT8 BMS1_DCChrgNeg1RelaySt;
extern UINT8 BMS1_DCChrgPos2RelaySt;
extern UINT8 BMS1_DCChrgNeg2RelaySt;
extern UINT8 BMS1_HeatPosRelaySt;
extern UINT8 BMS1_HeatNegRelaySt;
extern UINT8 BMS1_SysSts;
extern UINT8 BMS1_Life;
extern UINT8 BMS1_BalanceStatus;
extern UINT8 BMS1_DCChrgConnectSt;
extern UINT8 BMS1_ChrgMode;
extern UINT8 BMS1_ChrgStatus;
extern UINT8 BMS1_HeatingStatus;
extern UINT8 BMS1_CoolingStatus;
extern UINT8 BMS2_SOC;
extern UINT8 BMS2_SOH;
extern UINT8 BMS2_FaultCode;
extern UINT8 BMS2_FaultLevel;
extern UINT8 BMS2_RqHVPoerOff;
extern UINT8 BMS2_Life;
extern UINT8 BMS4_InsDetectorSt;
extern UINT8 BMS8_Max_Temp;
extern UINT8 BMS8_Min_Temp;
extern UINT8 BMS8_Avg_Temp;
extern UINT8 BMS8_MaxTempSysNr;
extern UINT8 BMS8_MaxTempNr;
extern UINT8 BMS8_MinTempSysNr;
extern UINT8 BMS8_MinTempNr;
extern UINT8 BMS7_MaxUcellSysNr;
extern UINT8 BMS7_MinUcellSysNr;
extern UINT8 BMS23_Gun1DCPosTemp;
extern UINT8 BMS23_Gun1DCNegTemp;
extern UINT8 BMS23_Gun2DCPosTemp;
extern UINT8 BMS23_Gun2DCNegTemp;
extern UINT8 BMS_Cell_TempN[64];
extern UINT8 BMS_SN_SysCode[24];
extern UINT8 BMS21_BattType;
extern UINT8 BMS21_CoolType;
extern UINT8 BMS21_Manufacture;
extern UINT8 BMS21_ProtocolEditionH;
extern UINT8 BMS21_ProtocolEditionL;
extern UINT8 BMS9_TotCSCNum;
extern UINT8 BMS9_PackTotTempNum;
extern UINT8 BMS9_HVBranchNum;
extern UINT8 BMS9_SingleHVBranchCellNum;
extern UINT8 BMS9_BattSysNum;
extern UINT8 BMS9_BattSysSeqNum;
extern UINT8 BMS22_AvaiMaxSOC;
extern UINT8 BMS22_AvaiMinSOC;
extern UINT8 BMS22_AvaiMaxTemp;
extern UINT8 BMS22_AvaiMinTemp;
extern UINT8 BMS10_SubSysEncodingLen;
extern UINT8 BMS10_SubSysIdx;
extern UINT8 BMS10_SubSysErrNum;
extern UINT8 BMS28_ReqMode;
extern UINT8 BMS28_HVCmd;
extern UINT8 BMS28_ChgSts;
extern UINT8 BMS28_HVRelaySts;
extern UINT8 BMS28_SetTemp;
extern UINT8 BMS28_Life;
extern UINT8 BMS28_CRC;
extern UINT8 TMS_WorkStatus;
extern UINT8 TMS_HVRelayST;
extern UINT8 TMS_OutletTemp;
extern UINT8 TMS_InletTemp;
extern UINT8 TMS_Version;
extern UINT8 TMS_ErrCode;
extern UINT8 TMS_FaultLevel;
extern UINT8 BCU_SnMsgFlag;
extern UINT16 BMS_Cell_Volt[384];
extern UINT16 BMS11_PackOutsideVolt;
extern UINT16 BMS2_PackCurrent;
extern UINT16 BMS2_PackInsideVolt;
extern UINT16 BMS4_PosIsolation;
extern UINT16 BMS4_NegIsolation;
extern UINT16 BMS4_SysInsRes;
extern UINT16 BMS6_Max_Ucell;
extern UINT16 BMS6_Min_Ucell;
extern UINT16 BMS6_Avg_Ucell;
extern UINT16 BMS6_SOE;
extern UINT16 BMS7_MaxUcellNr;
extern UINT16 BMS7_MinUcellNr;
extern UINT16 BMS23_RemainChgTi;
extern UINT16 BMS21_RateCap;
extern UINT16 BMS21_RateHVolt;
extern UINT16 BMS21_RatePower;
extern UINT16 BMS9_PackTotCellNum;
extern UINT16 BMS22_PackAvaiMaxVolt;
extern UINT16 BMS22_PackAvaiMinVolt;
extern UINT16 BMS_SoftwareVersion;
extern UINT16 BMS_HardwareVersion;
extern UINT16 BMS3_MaxDischgPow;
extern UINT16 BMS3_MaxChgPow;
extern UINT16 BMS3_MaxInstantDischgPow;
extern UINT16 BMS3_MaxiInstantChgPow;
extern UINT16 BMS5_DischgCurMaxAllw;
extern UINT16 BMS5_ChrgCurMaxAllw;
extern UINT16 BMS5_InstChrgCurMaxAllw;
extern UINT16 BMS5_InstDischrgCurMaxAllw;
extern UINT16 BMS26_Bat_InstantConsume;
extern UINT16 BMS26_Bat_TotalConsume;
extern UINT16 BMS26_ChgReqVoltage;
extern UINT16 BMS26_ChgReqCurrent;
extern UINT16 BMS28_HVVolt;
extern UINT16 TMS_ReqPow;
extern UINT32 BMS1_RechrgCycels;
extern UINT32 BMS14_TotalChargeAh;
extern UINT32 BMS14_TotalDischargeAh;
extern UINT32 BMS15_TotalChargeKwh;
extern UINT32 BMS15_TotalDischargeKwh;
extern UINT32 BMS16_TotalEneryECOChargeAh;
extern UINT32 BMS16_TotalEneryECOChargeKwh;
extern UINT32 BMS17_TotalStationChargeAh;
extern UINT32 BMS17_TotalStationChargeKwh;
extern UINT32 BMS18_TotalPoleChargeAh;
extern UINT32 BMS18_TotalPoleChargeKwh;
extern UINT32 BMS19_SingleChargeAh;
extern UINT32 BMS19_SingleChargeKwh;
/*************************************************************
 *Ebc->Bcu
 ************************************************************/
extern UINT32 Ebc2BcuOutTable[5][2];
// extern UINT8 VCU_Life;

extern UINT8 VCU_ReqHV;
extern UINT8 VCU_DCDCSts;
extern UINT8 VCU_DCACSts;
extern UINT8 VCU_DCAPSts;
// extern UINT8 VCU_VehicleSpeed;

extern UINT8 VCU_PosRlySts;
extern UINT8 VCU_PosRlyErrSts;
extern UINT8 VCU_PTCRlSts;
extern UINT8 VCU_PTCRlErrSts;
extern UINT8 VCU_StopChgCmd;
extern UINT8 VCU_HVInterlock;
extern UINT8 VCU_AssistRlySts;
extern UINT8 VCU_AssistRlyErrSts;
extern UINT8 VCU_ACRlySts;
extern UINT8 VCU_ACRlyErrSts;
extern UINT8 ISO_WorkStatus;
extern UINT8 ISO_FaultLevel;
extern UINT8 VIN_FrameNo;
extern UINT8 VCU_VIN[17];
extern UINT8 EBC_State;
extern UINT8 EBC_ForbidHVOn;
extern UINT8 EBC_RequestHVOff;
extern UINT8 EBC_ChgFaultFlag;
extern UINT8 EBC_LockupFaultFlag;
extern UINT8 EBC_ChgCnctOverTemp;
extern UINT8 EBC_DischgHIVLFlag;
extern UINT8 EBC_ChargeHIVLFlag;
extern UINT8 EBC_DChgCnctOverTemp;
extern UINT8 EBC_FaultLevel;
extern UINT8 EBC_FaultCode;
extern UINT8 EBC_ChargingStatus;
extern UINT8 EBC_ActiveHeatReq;
extern UINT8 EBC_AirPressure;
// extern UINT8 EBC_Life;
// extern UINT8 EBC_ChgPos1Temp;
// extern UINT8 EBC_ChgNeg1Temp;
// extern UINT8 EBC_ChgPos2Temp;
// extern UINT8 EBC_ChgNeg2Temp;
// extern UINT8 EBC_DchgPos1Temp;
// extern UINT8 EBC_DchgNeg1Temp;
// extern UINT8 EBC_DchgPos2Temp;
// extern UINT8 EBC_DchgNeg2Temp;
extern UINT16 ISO_PosResis;
extern UINT16 ISO_NegResis;
/*************************************************************
 *Vcu->Ebc
 ************************************************************/
extern UINT8 VcuRxFlag[8];
extern UINT32 VcuInTable[8];
extern BOOL VcuRxShortError[8];
extern BOOL VcuRxLongError[8];
extern UINT8 VcuRxErrorCount[8];
extern UINT8 Checksum;
extern UINT8 VCU_Life;
extern UINT8 VCU_HvOnOff;
extern UINT8 VCU_AuxOnOff;
extern UINT8 VCU_VehicleSpeed;
extern UINT8 VCU_HeatOnOff;
extern UINT8 VCU_MainPosRlySts;
extern UINT8 VCU_MainNegRlySts;
extern UINT8 VCU_PreChgRlySts;
extern UINT8 VCU_AuxRlySts;
extern UINT8 VCU_MainMotRlySts;
extern UINT8 VCU_MainMotRlyErrSts;
extern UINT8 VCU_Assist1RlySts;
extern UINT8 VCU_Assist1RlyErrSts;
extern UINT8 VCU_Assist2RlySts;
extern UINT8 VCU_Assist2RlyErrSts;
extern UINT8 VCU_Assist3RlySts;
extern UINT8 VCU_Assist3RlyErrSts;
extern UINT8 VCU_Assist4RlySts;
extern UINT8 VCU_Assist4RlyErrSts;
extern UINT8 VCU_VIN[17];
extern UINT8 DrvMotPosRySts;
extern UINT8 VehSts;
extern UINT8 BrakePedal;
extern UINT8 HandbrakeSts;
extern UINT8 GearPos;
extern UINT16 VehSpd;
extern UINT32 VCU_TotalDistance;
extern UINT8 EBC_VinMsgFlag;
/*************************************************************
 *Ebc->Vcu
 ************************************************************/
extern UINT32 Ebc2VcuOutTable[25][2];
extern UINT8 ReqVIN;
extern UINT8 ReqHVOff;
extern UINT8 ChgSysNum;
extern UINT8 Fult2_MainPosRelayWeldErr;
extern UINT8 Fult2_MainNegRelayWeldErr;
extern UINT8 Fult2_DCChgPos1RelayWeldErr;
extern UINT8 Fult2_DCChgNeg1RelayWeldErr;
extern UINT8 Fult2_DCChgPos2RelayWeldErr;
extern UINT8 Fult2_DCChgNeg2RelayWeldErr;
extern UINT8 HeatPosRelayWeldErr;
extern UINT8 HeatNegRelayWeldErr;
extern UINT8 MainPosRelaySt;
extern UINT8 MainNegRelaySt;
extern UINT8 PreChgRelaySt;
extern UINT8 DCChrgPos1RelaySt;
extern UINT8 DCChrgNeg1RelaySt;
extern UINT8 DCChrgPos2RelaySt;
extern UINT8 DCChrgNeg2RelaySt;
extern UINT8 AuxRelayWeldErr;
extern UINT8 Fult2_BranchBreakErr;
extern UINT8 Fult2_OverChrgCurrInTheDrive;
extern UINT8 Fult2_MainPosRelayOpenErr;
extern UINT8 Fult2_MainNegRelayOpenErr;
extern UINT8 Fult2_DCChgPos1RelayOpenErr;
extern UINT8 Fult2_DCChgPos2RelayOpenErr;
extern UINT8 Fult2_DCChgNeg1RelayOpenErr;
extern UINT8 Fult2_DCChgNeg2RelayOpenErr;
extern UINT8 Fult2_HeatRelayWeldErr;
extern UINT8 Fult2_HeatRelayOpenErr;
extern UINT8 Fult2_TMSErr;
extern UINT8 Fult2_PowerSupplyErr;
extern UINT8 Fult2_PackSelfProtect;
extern UINT8 Fult2_ChrgNTCTempOver;
extern UINT8 BattSysNum;
extern UINT8 BatSysFaultCode;
extern UINT8 ST1_CheckSum;
extern UINT8 ST1_Life;
extern UINT8 BMS_SysSts;
extern UINT8 AssisRelaySts;
extern UINT8 BlanceSts;
extern UINT8 DCChrgConnectSt;
extern UINT8 ChrgMode;
extern UINT8 ChrgStatus;
extern UINT8 FaultLevel;
extern UINT8 Fult1_DelTemp;
extern UINT8 Fult1_OverTemp;
extern UINT8 Fult1_PackOverHVolt;
extern UINT8 Fult1_PackLowHVolt;
extern UINT8 Fult1_LowSOC;
extern UINT8 Fult1_OverUcell;
extern UINT8 Fult1_LowUcell;
extern UINT8 Fult1_LowInsRes;
extern UINT8 Fult1_UcellUniformity;
extern UINT8 Fult2_CellLowTemp;
extern UINT8 Fult2_OverDischrgCurr;
extern UINT8 Fult2_OverChrgCurrInTheChrg;
extern UINT8 Fult_BranchVolUniformity;
extern UINT8 Fult_BMSHardware;
extern UINT8 Fult1_OverSOC;
extern UINT8 Fult1_SOCChangeFast;
extern UINT8 Fult2_InnerCommunicationErr;
extern UINT8 Fult1_BatSysNotMatch;
extern UINT8 Fult1_HVILFault;
extern UINT8 Fult2_FireDetectorEr;
extern UINT8 Fult2_PackFireWarning;
extern UINT8 Fult2_FaultNum;
extern UINT8 SOC;
extern UINT8 SOH;
extern UINT8 Max_Temp;
extern UINT8 Min_Temp;
extern UINT8 Avg_Temp;
extern UINT8 MaxTempSysNr;
extern UINT8 MaxTempNr;
extern UINT8 MinTempSysNr;
extern UINT8 MinTempNr;
extern UINT8 MaxUcellSysNr;
extern UINT8 MaxUcellNr;
extern UINT8 MinUcellSysNr;
extern UINT8 MinUcellNr;
extern UINT8 Gun1DCNegTemp;
extern UINT8 Gun1DCPosTemp;
extern UINT8 Gun2DCNegTemp;
extern UINT8 Gun2DCPosTemp;
extern UINT8 HeatPosRelaySt;
extern UINT8 HeatNegRelaySt;
extern UINT8 UcellFrameNum;
extern UINT8 UcellCSCNum;
extern UINT8 TempFrameNum;
extern UINT8 TempCSCNum;
// extern UINT8 CurCSC_TempN;
// extern UINT8 CurCSC_TempN1;
// extern UINT8 CurCSC_TempN2;
// extern UINT8 CurCSC_TempN3;
// extern UINT8 CurCSC_TempN4;
// extern UINT8 CurCSC_TempN5;

extern UINT8 BattType;
extern UINT8 CoolType;
extern UINT8 TotCSCNum;
extern UINT8 CellVoltPlat;
extern UINT8 MinAvlCellVolt;
extern UINT8 MaxAvlCellVolt;
extern UINT8 EBC_DchgPos1Temp;
extern UINT8 EBC_DchgNeg1Temp;
extern UINT8 EBC_DchgPos2Temp;
extern UINT8 EBC_DchgNeg2Temp;
extern UINT8 EBC_ChgPos1Temp;
extern UINT8 EBC_ChgNeg1Temp;
extern UINT8 EBC_ChgPos2Temp;
extern UINT8 EBC_ChgNeg2Temp;
extern UINT8 ReqMode;
extern UINT8 HVCmd;
extern UINT8 ChgSts;
extern UINT8 HVRelaySts;
extern UINT8 SetTemp;
extern UINT8 Bms_Life;
extern UINT8 CRC;
extern UINT8 TMS_WorkStatus;
extern UINT8 TMS_HVRelayST;
extern UINT8 TMS_OutletTemp;
extern UINT8 TMS_InletTemp;
extern UINT8 TMS_ErrCode;
extern UINT8 TMS_FaultLevel;
// extern UINT8 EBC_Life;

extern UINT8 EBC_LockupSts;
extern UINT8 EBC_ConnectorSts;
extern UINT8 EBC_DischgConnectorSts;
extern UINT8 EBC_ChgConnectorSts;
extern UINT8 EBC_FaultLevel;
extern UINT8 EBC_FaultCode;
extern UINT16 BMS_SoftwareVersion;
extern UINT16 BMS_HardwareVersion;
extern UINT16 PackCurrent;
extern UINT16 InstChrgCurMaxAllw;
extern UINT16 InstDischrgCurMaxAllw;
extern UINT16 PosIsolation;
extern UINT16 NegIsolation;
extern UINT16 PackInsideVolt;
extern UINT16 PackOutsideVolt;
extern UINT16 Max_Ucell;
extern UINT16 Avg_Ucell;
extern UINT16 Min_Ucell;
extern UINT16 ChrgCurMaxAllw;
// extern UINT16 CurCSC_UCellN;
// extern UINT16 CurCSC_UCellN1;
// extern UINT16 CurCSC_UCellN2;

extern UINT16 Pack_RateCap;
extern UINT16 Pack_RateHVolt;
extern UINT16 Pack_RatePower;
extern UINT16 PackTotCellNum;
extern UINT16 PackTotTempNum;
extern UINT16 SingleChargeKwh;
extern UINT16 HVVolt;
// extern UINT16 TMS_ReqPow;

extern UINT32 TotalChargeKwh;
extern UINT32 TotalDischargeKwh;
extern UINT32 TotalEneryECOChargeKwh;
extern UINT32 TotalStationChargeKwh;
extern UINT32 TotalPoleChargeKwh;
/*************************************************************
 *Ebc->ble
 ************************************************************/
extern uint16 CANNet_rAccPedUW;
extern uint32 PressureValue;
extern uint16 Distence1;
extern uint16 Distence2;
extern uint8 Switch1;
extern uint8 Switch2;
extern uint8 ControlState;
extern uint32 Control_Times;
extern uint32 PressureValueBuffer;
extern uint32 VehCo_fInputUIA[2];
extern uint16 VehCo_rInputUWA[2];
extern uint16 VehCo_uADChanUWA[_ATD_NUM_CHAN];
extern uint8 VehCo_bDINChanUBA[_DIN_NUM_CHAN];
extern float32 VehCo_uBattF;
extern uint16 VehCo_uAccPedUW;
#define EEPDATA_START_SEC_VAR
#include "MemMap.h"
extern uint32 VehCo_ctEEPTestUB;
extern uint32 VehCo_ctEEPTestUI; //ڶʱEEPROMıֵ
extern uint32 Control_Times;
#define EEPDATA_STOP_SEC_VAR
#include "MemMap.h"
// Ble
extern uint16 bcud_E_snglChrg;       //γ0.1kwh
extern uint16 ebcd_Nr_swapBatt;      //
extern uint16 ebcd_Nr_swapSucBatt;   //ɹ
extern uint16 bcud_pct_soc;          //SOC0.1
extern uint16 bcud_Q_snglChrg;       //γ0.1Ah
extern uint16 bcud_V_battU;          //صѹ 0.1V
extern uint32 bcud_E_accChrg;        //ۼƳ0.1kwh
extern uint32 bcud_E_accDischrg;     //ۼƷŵ0.1kwh
extern uint32 bcud_E_accPlugInChrg;  //ۼƲǹ0.1kwh
extern uint32 bcud_E_accRecovry;     //ۼƻ0.1kwh
extern uint32 bcud_E_accSwapBatt;    //ۼƻվ0.1kwh
extern uint32 bcud_Q_accChrg;        //ۼƳ0.1ah
extern uint32 bcud_Q_accDischrg;     //ۼƷŵ0.1ah
extern uint32 bcud_Q_accPlugInChrg;  //ۼƲǹ0.1ah
extern uint32 bcud_Q_accRecovry;     //ۼƻ0.1ah
extern uint32 bcud_Q_accSwapBatt;    //ۼƻվ0.1ah
extern uint32 vcud_M_accDrv;         //ۼʻ,0.1km
extern uint8 bcud_pct_bcuSoh;        //Soh0.4%
extern uint8 bcud_st_bcuComun;       //ͨѶ״̬,0-ͨж,1-ͨ
extern uint8 bcud_st_bcuMainRelay;   //̵ź,0- 1-Ͽ,2-ر 3-쳣
extern uint8 bcud_st_bcuTmsLiquid;   //ȹҺλ״̬,1-Һλ,0-Һλ
extern uint8 bcud_st_hvWork;         //ظѹ״̬0-ѹ 1-Ԥ䣬2-ѹضϣ3-ѹϵ
extern uint8 bcuv_Num_battSn[32];    //SN
extern uint8 ebcd_flg_pluginLockSig; //Ӳź״̬,1-,0-޴
extern uint8 ebcd_flg_swapAdmit;     //жϣ0-,1-
extern uint8 ebcd_Nr_errMax;         //ϵȼǰȼ
extern uint8 ebcd_Num_err1;          //1
extern uint8 ebcd_Num_err2;          //2
extern uint8 ebcd_st_ebcConnect;     // EbcͨѶģʽ0-1- Ĭ0
extern uint8 ebcd_st_ebcLockWork;    // Ebcģʽ0-ģʽ1-Զģʽ
extern uint8 ebcd_st_ebcWork;        // Ebcǰ״̬ 0-г1-ͨѶ2-
extern uint8 ebcd_st_errTable1;      //ϱ1bit0-ѹ쳣bit1-Һλ쳣bit2-Flashȡ쳣
extern uint8 ebcd_st_errTable2;      //ϱ2bit0-쳣bit1-CAN쳣bit2-CAN쳣bit3-쳣bit4-쳣bit5-λ쳣
extern uint8 ebcd_st_errTable3;      //ϱ3bit0-ŵ绥쳣bit1-绥쳣bit2-ѹ쳣
extern uint8 ebcd_st_lockSensor;     //źţbit0-bit30-3״̬ÿbit1-0-
extern uint8 ebcd_st_lockSucJug;     //жϣ0-ȫδ,1-ȫ,2-δȫ"
extern uint8 ebcd_st_pedstSensor;    //bit0-bit10-1״̬,ÿbit1-0-޴
extern uint8 ebcd_st_pedstSucJug;    //صλжϣ0-ȫδλ,1-ȫλ,2-δȫλ
extern uint8 ebcd_st_pluginLockSig;  //Ӳźž״̬,1-,0-޴
extern uint8 ebcd_st_unlockSensor;   //źţbit0-bit30-3״̬ÿbit1-0-
extern uint8 ebcd_st_unlockSucJug;   //жϣ0-ȫδ1-ȫ2-δȫ
// extern uint8 vcud_P_airSensor;            //ѹѹֵλMpa0.01Mpa
extern uint8 vcud_P_airSensorBack;        //ѹֵλMpa0.01Mpa
extern uint8 vcud_P_airSensorForward;     //ǰѹֵλMpa0.01Mpa
extern uint8 vcud_st_carStart;            //״̬0001-״̬0010-Ϩ0011-״̬1111-Ч
extern uint8 vcud_st_footbrake;           //ɲźţ0-Ч1-Ч
extern uint8 vcud_st_gear;                //λźţFF-R0-յNX-ǰDXXȡ1-12
extern uint8 vcud_st_handbrake;           //ɲźţ0-Ч1-Ч
extern uint8 vcud_st_keyOn;               //Կźţ1-ϵ磬0-µ
extern uint8 vcud_st_Steer;               //źţbit0-תƣbit1-Ҳתƣÿbit 0-OFF1-ON
extern uint8 vcud_st_vcuComun;            // vcuͨѶ״̬0-ͨж,1-ͨ
extern uint8 vcuv_Num_vin[17];            // VIN
extern uint8 bled_flg_lockCmd;            //ŷ1-Ч0-Ч
extern uint8 bled_flg_unlockCmd;          //ŷ1-Ч0-Ч
extern uint8 bled_flg_lockCmdForce;       //ŷǿ1-Ч0-Ч
extern uint8 bled_flg_unlockCmdForce;     //ŷǿ1-Ч0-Ч
extern uint8 bled_flg_topAscendCmd;       //1-Ч0-Ч
extern uint8 bled_flg_topDescendCmd;      //½1-Ч0-Ч
extern uint8 bled_flg_topAscendCmdForce;  //ǿ1-Ч0-Ч
extern uint8 bled_flg_topDescendCmdForce; //ǿ½1-Ч0-Ч
extern uint8 bled_flg_openDustReCmd;      //ָ1-Ч0-Ч
extern uint8 bled_flg_closeDustReCmd;     //رָ1-Ч0-Ч
extern uint8 bled_flg_Heart;              //άָ
extern uint8 bled_flg_getEbcData;         //ȡebcָ
extern uint8 bled_flg_getVcuData;         //ȡvcuָ
extern uint8 bled_flg_getBmsData;         //ȡbmsָ
extern uint8 bled_flg_handShake;          //ָ
extern uint8 bled_flg_swapBattDone;       //ָ
extern uint8 bled_flg_backToDrv;          //صʻ״ָ̬
extern uint8 bled_flg_autoLock;           //Զָ
extern uint8 bled_flg_autoUnlock;         //Զָ
extern uint8 bled_flg_toSwapMod;          //״̬
extern uint8 bled_flg_safeStopCmd;        //ָͣ
extern uint32 bled_Nr_softVer;            // BLE汾
extern uint8 bled_flg_role;               // bleģʽ 01-02-
extern uint8 bled_flg_bleConn;            // ble״̬
extern uint8 bled_flg_bleDisconn;         // bleϿ״̬
//ʽ
extern uint8 ebcd_P_airSensor;
extern uint8 ebcd_T_plugin[4];          //ĸӲ¶
extern uint8 ebcd_flg_forbidHVOn;       //ֹѹϵ
extern uint8 ebcb_flg_reqHvOff;         //ѹµ
extern uint8 ebcd_flg_LockErr;          //״̬
extern uint8 ebcd_flg_dChrgLockErr;     //ŵ绥״̬
extern uint8 ebcd_flg_chrgLockErr;      //绥״̬
extern uint8 ebcd_flg_dChgCnctOverTemp; //ŵ±־
extern uint8 ebcd_st_ebcWork;           // Ebcǰ״̬ 0-г1-ͨѶ2-
extern uint8 ebcd_Nr_errMax;            //ϵȼǰȼ
extern uint8 ebcd_Num_faultCode;        // ebc룬δ
extern uint8 ebcd_st_chargingMod;       //ģʽ1-س磬2-վ
extern uint8 ebdc_st_lockUpState;       //ֹ״̬0-ϣ1-ɹ2-ɹ
extern uint8 ebdc_st_ConnecState;       //״̬·&ŵ·ͬʱպϴպϣһ·ϿΪϿ0_δ 1_

extern const uint16 T_table[240];
extern const uint32 R_table[240];
#endif /* SYSTEM_VEHICLE_COMMUNICATION_CANVAR_H_ */
